unit fMain;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ComCtrls,
  ActnList,
  Buttons,
  ImgList,
  XMLDoc,
  XMLIntf,
  XPMan,
  oScript,
  oScriptColumn,
  oScriptTypes,
  oFMFile,
  oMyBroker,
  oFMField,
  mFMField,
  ExtCtrls,
  ToolWin,
  Menus;

type
  TfrmMain = class(TForm)
    ActionList1: TActionList;
    acInitialize: TAction;
    ImageList1: TImageList;
    acMoveUp: TAction;
    acMoveDown: TAction;
    acAddField: TAction;
    acDelField: TAction;
    acNewCommand: TAction;
    acLoadScripts: TAction;
    acUnloadScripts: TAction;
    acSelectScript: TAction;
    acSelectFile: TAction;
    acUnloadForm: TAction;
    acLoadForm: TAction;
    acLoadFiles: TAction;
    acUnloadFiles: TAction;
    acBuildSQLScript: TAction;
    acDeleteCommand: TAction;
    acSaveAll: TAction;
    acViewFilemanScript: TAction;
    acBuildInitializationFile: TAction;
    acInstallCommandsToVistA: TAction;
    acReNameScript: TAction;
    ToolBar2: TToolBar;
    gbxInstalling: TGroupBox;
    memInstalling: TMemo;
    tvScripts: TTreeView;
    Splitter1: TSplitter;
    acConvertIt: TAction;
    acSaveCommand: TAction;
    acRefreshListView: TAction;
    pnlMain: TPanel;
    pnlScript: TPanel;
    Label1: TLabel;
    Label3: TLabel;
    Label2: TLabel;
    Label11: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label5: TLabel;
    edtFileNumber: TEdit;
    edtGlobalRoot: TEdit;
    edtMExecuteRoutine: TEdit;
    cbxFile: TComboBox;
    edtSQLViewName: TEdit;
    edtSQLWhereClause: TEdit;
    edtMWhereClause: TEdit;
    edtScriptComment: TEdit;
    pnlControls: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton2: TSpeedButton;
    lvColumns: TListView;
    pnlColumns: TPanel;
    Label6: TLabel;
    acEditField: TAction;
    PopupMenu1: TPopupMenu;
    mnNewUpdate: TMenuItem;
    mnNewInsert: TMenuItem;
    mnNewQuery: TMenuItem;
    mnNewDelete: TMenuItem;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    lblScriptDefinition: TLabel;
    pnlCommands: TPanel;
    mnNewDeleteAll: TMenuItem;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    acInstallThisCommand: TAction;
    Bevel3: TBevel;
    Bevel4: TBevel;
    StoredProcedure1: TMenuItem;
    Label4: TLabel;
    edtIndex: TEdit;
    cbxCached: TComboBox;
    Label7: TLabel;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    acCopyToClipboard: TAction;
    procedure acInitializeExecute(Sender: TObject);
    procedure acLoadScriptsExecute(Sender: TObject);
    procedure acUnloadScriptsExecute(Sender: TObject);
    procedure acSaveCommandExecute(Sender: TObject);
    procedure acSelectFileExecute(Sender: TObject);
    procedure acAddFieldExecute(Sender: TObject);
    procedure acUnloadFormExecute(Sender: TObject);
    procedure acLoadFormExecute(Sender: TObject);
    procedure acLoadFilesExecute(Sender: TObject);
    procedure acUnloadFilesExecute(Sender: TObject);
    procedure acBuildSQLScriptExecute(Sender: TObject);
    procedure acDelFieldExecute(Sender: TObject);
    procedure acMoveUpExecute(Sender: TObject);
    procedure acMoveDownExecute(Sender: TObject);
    procedure acNewCommandExecute(Sender: TObject);
    procedure acDeleteCommandExecute(Sender: TObject);
    procedure acBuildInitializationFileExecute(Sender: TObject);
    procedure acInstallCommandsToVistAExecute(Sender: TObject);
    procedure acReNameScriptExecute(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure acConvertItExecute(Sender: TObject);
    procedure acRefreshListViewExecute(Sender: TObject);
    procedure acEditFieldExecute(Sender: TObject);
    procedure acViewFilemanScriptExecute(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure tvScriptsDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure tvScriptsDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure tvScriptsChange(Sender: TObject; Node: TTreeNode);
    procedure tvScriptsGetImageIndex(Sender: TObject; Node: TTreeNode);
    procedure acInstallThisCommandExecute(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    procedure tvScriptsEdited(Sender: TObject; Node: TTreeNode; var S: string);
    procedure cbxFileKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ToolButton8Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure acCopyToClipboardExecute(Sender: TObject);
  private
    fVistABroker: TMyBroker;
    fXMLDocument: IXMLDocument;
    fScripts: TList;
    fColumns: TList;
    fFMFiles: TStringList;
    fFMFields: TStringList;
    fScriptNodes: array[TScriptType] of TTreeNode;
    function CommaList(aList: TStringList): string;
    function ParamList(aCount: integer): string;
    function ValueList(aList: TStringList): string;
    function InstallOneScript(aScript: TScript): boolean;
    procedure AddMessage(aLine: string);
  public
    { Public declarations }
  end;

const
  COMMAND_FILE_NAME = '.\CliO_Scripts.xml';
  EXPORT_FILE_NAME = 'c:\Initialize_CliO_SQL.xml';

var
  frmMain: TfrmMain;
  fCurrentScript: TScript;
  fCurrentFile: TFMFile;

implementation

uses
  Clipbrd,
  fColumnDefinition,
  fAboutDlg,
  fSplash;

{$R *.dfm}

procedure TfrmMain.AddMessage(aLine: string);
begin
  memInstalling.Lines.Add(aLine);
end;

function TfrmMain.InstallOneScript(aScript: TScript): boolean;
var
  aText: TStringList;
begin
  AddMessage(
    Format('Installing %s - %s (%s) ...', [aScript.Name, aScript.Comment, aScript.FMFile]));
  aText := TStringList.Create;
  //  aCMD := TScript(fScripts[i]);
  aScript.GetVistAScript(aText);
  if aText.Count > 0 then
    begin
      fVistABroker.CallServer(['SAVECMD', aScript.Name, aScript.Comment, aScript.FMFile, aScript.Cached], aText);
      AddMessage(fVistABroker.Results.Text);
    end
  else
    begin
      memInstalling.Lines.Add('Error, no text for ' + aScript.Name + '...');
    end;
end;

procedure TfrmMain.tvScriptsChange(Sender: TObject; Node: TTreeNode);
begin
  fCurrentScript := nil;
  acUnloadForm.Execute;

  if Node <> nil then
    if Node.Data <> nil then
      begin
        fCurrentScript := TScript(Node.Data);
        acLoadForm.Execute;
      end;

  pnlScript.Visible := Assigned(fCurrentScript);
  pnlCommands.Visible := Assigned(fCurrentScript);
  tvScripts.ReadOnly := (not Assigned(fCurrentScript));

  if Assigned(fCurrentScript) then
    pnlColumns.Visible := (fCurrentScript.ScriptType in [stQuery, stInsert, stUpdate])
  else
    pnlColumns.Visible := False;

  acSaveCommand.Enabled := Assigned(fCurrentScript);
  acDeleteCommand.Enabled := Assigned(fCurrentScript);
  acViewFilemanScript.Enabled := Assigned(fCurrentScript);
  acCopyToClipboard.Enabled := Assigned(fCurrentScript);
  acInstallThisCommand.Enabled := Assigned(fCurrentScript);
end;

procedure TfrmMain.acInitializeExecute(Sender: TObject);
var
  aNode: IXMLNOde;
  aFile: TFMFile;
  aType: TScriptType;
begin
  pnlScript.DoubleBuffered := True;
  pnlColumns.DoubleBuffered := True;
  pnlControls.DoubleBuffered := True;

  fScripts := TList.Create;
  fColumns := TList.Create;

  lblScriptDefinition.Font.Size := 11;
  lblScriptDefinition.Font.Style := [fsBold];

  fXMLDocument := NewXMLDocument;
  if FileExists(COMMAND_FILE_NAME) then
    fXMLDocument.LoadFromFile(COMMAND_FILE_NAME)
  else
    fXMLDocument.DocumentElement := fXMLDocument.AddChild('SCRIPTS');

  memInstalling.Lines.Clear;
  //AddMessage('Loading Scripts ...');
  UpdateSplashScreen('Loading Scripts ...');
  acLoadScripts.Execute;
  acLoadFiles.Execute;
  acUnloadForm.Execute;
  Width := Width + 2; {Cause a resize of stuff}
  UpdateSplashScreen(Format('Ready, %d scripts loaded.', [fScripts.Count]));

end;

procedure TfrmMain.acSaveCommandExecute(Sender: TObject);
var
  aNode: IXMLNode;
  aCol: TScriptColumn;
  i: integer;
  aName: string;
  aType: TScriptType;
begin
  if fCurrentScript <> nil then
    with fCurrentScript do
      try
        {ShowMessage('Before: ' + #13 + FormatXMLData(XMLNode.XML));}

        aName := Name;
        aType := ScriptType;

        XMLNode.ChildNodes.Clear;
        XMLNode.AttributeNodes.Clear;

        Name := aName;
        ScriptType := aType;

        Comment := edtScriptComment.Text;
        FMRoot := edtGlobalRoot.Text;
        FMFile := edtFileNumber.Text;
        FMIndex := edtIndex.Text;
        MExecute := edtMExecuteRoutine.Text;
        MWhere := edtMWhereClause.Text;
        Cached := IntToStr(cbxCached.ItemIndex);

        aNode := fCurrentScript.ColumnNode;
        aNode.ChildNodes.Clear;
        for i := 0 to lvColumns.Items.Count - 1 do
          with aNode.AddChild('COLUMN') do
            begin
              aCol := TScriptColumn(lvColumns.Items[i].Data);
              Attributes['TAG'] := aCol.XMLTag;
              ChildValues['FM_FIELD'] := aCol.FMFieldNumber;
              ChildValues['FM_DATATYPE'] := aCol.FMFieldType;
              ChildValues['INTERNAL_FORMAT'] := aCol.FInternalFormat;
              ChildValues['COMMENT'] := aCol.Comment;
            end;

        {ShowMessage('After: ' + #13 + FormatXMLData(XMLNode.XML));}
        fXMLDocument.SaveToFile(COMMAND_FILE_NAME);
        tvScripts.Invalidate;
      except
        on e: exception do
          MessageDlg('Error saving script:' + e.Message, mtError, [mbOk], 0);
      end;
end;

procedure TfrmMain.acSelectFileExecute(Sender: TObject);
begin
  edtFileNumber.Text := '';
  edtGlobalRoot.Text := '';
  cbxCached.ItemIndex := 0;
  //edtMExecuteRoutine.Text := '';
  //edtMWhereClause.Text := '';

  if cbxFile.ItemIndex = -1 then
    fCurrentFile := nil
  else
    begin
      fCurrentFile := TFMFile(cbxFile.Items.Objects[cbxFile.ItemIndex]);

      with fCurrentFile do
        begin
          edtFileNumber.Text := Number;
          edtGlobalRoot.Text := Root;
          LoadFields(fVistABroker);
        end;
    end;
end;

procedure TfrmMain.acLoadFormExecute(Sender: TObject);
var
  i: integer;
  aNode: IXMLNode;
  aColumn: TScriptColumn;
begin
  acUnloadForm.Execute;

  for i := 0 to cbxFile.Items.Count - 1 do
    if TFMFile(cbxFile.Items.Objects[i]).Number = fCurrentScript.FMFile then
      begin
        cbxFile.ItemIndex := i;
        fCurrentFile := TFMFile(cbxFile.Items.Objects[i]);
        fCurrentFile.LoadFields(fVistABroker);
        Break;
      end;

  edtFileNumber.Text := fCurrentScript.FMFile;
  edtGlobalRoot.Text := fCurrentScript.FMRoot;
  edtMWhereClause.Text := fCurrentScript.MWhere;
  edtIndex.Text := fCurrentScript.FMIndex;
  edtMExecuteRoutine.Text := fCurrentScript.MExecute;
  edtSQLWhereClause.Text := '';
  edtSQLViewName.Text := '';
  cbxCached.ItemIndex := StrToIntDef(fCurrentScript.Cached, 0);
  edtScriptComment.Text := fCurrentScript.Comment;

  ///acInstallThisCommand.Caption := Format('Install ''%s'' ...', [fCurrentScript.Name]);
  lblScriptDefinition.Caption := Format('Script ''%s'' Definition', [fCurrentScript.Name]);

  aNode := fCurrentScript.ColumnNode.ChildNodes.First;
  while Assigned(aNode) do
    begin
      aColumn := NewScriptColumn(aNode);
      if Assigned(aColumn) then
        with lvColumns.Items.Add do
          Data := aColumn;
      aNode := aNode.NextSibling;
    end;
  acRefreshListView.Execute;
end;

procedure TfrmMain.acUnloadFormExecute(Sender: TObject);
var
  i: integer;
begin
  edtScriptComment.Text := '';
  cbxFile.ItemIndex := -1;
  cbxCached.ItemIndex := -1;
  edtFileNumber.Text := '';
  edtGlobalRoot.Text := '';
  edtMExecuteRoutine.Text := '';
  edtMWhereClause.Text := '';
  edtIndex.Text := '';

  {Clear the columns}
  while lvColumns.Items.Count > 0 do
    begin
      if Assigned(lvColumns.Items[0].Data) then
        begin
          TFMField(lvColumns.Items[0].Data).Free;
          lvColumns.Items[0].Data := nil;
          lvColumns.Items.Delete(0);
        end;
    end;

end;

procedure TfrmMain.acLoadFilesExecute(Sender: TObject);
var
  aNode: IXMLNode;
  aFile: TFMFile;
begin
  fVistABroker.CallServer(['GETFILES'], nil);
  with NewXMLDocument do
    begin
      XML.Text := fVistABroker.Results.Text;
      Active := True;
      aNode := DocumentElement.ChildNodes.FindNode('FILELIST');
      if aNode <> nil then
        begin
          aNode := aNode.ChildNodes.First;
          while aNode <> nil do
            begin
              aFile := NewFMFile(aNode);
              if aFile <> nil then
                cbxFile.Items.AddObject(Format('%s (#%s)', [aFile.Name, aFile.Number]), aFile);
              aNode := aNode.NextSibling;
            end;
        end;
    end;
end;

procedure TfrmMain.acUnloadFilesExecute(Sender: TObject);
begin
  while cbxFile.Items.Count > 0 do
    begin
      TFMFile(cbxFile.Items.Objects[0]).Free;
      cbxFile.Items.Delete(0);
    end;
end;

procedure TfrmMain.acLoadScriptsExecute(Sender: TObject);
var
  aScript: TScript;
  aScriptType: TScriptType;
  aNode: IXMLNode;
begin
  acUnloadScripts.Execute;
  tvScripts.Items.Clear;
  tvScripts.Items.Add(nil, 'CliO Scripts');
  for aScriptType := Low(TScriptType) to High(TScriptType) do
    fScriptNodes[aScriptType] := tvScripts.Items.AddChild(tvScripts.Items.GetFirstNode, SCRIPT_TYPE_NAME[aScriptType]);

  aNode := fXMLDocument.DocumentElement.ChildNodes.First;
  while aNode <> nil do
    begin
      try
        aScript := NewScript(aNode);
      except
        on E: Exception do
          begin
            AddMessage('Error Loading Script ' + #13 + E.Message + #13 + 'XML Node:' + #13 + aNode.XML);
            FreeAndNil(aScript);
          end;
      end;

      if aScript <> nil then
        begin
          fScripts.Add(aScript);
          tvScripts.Items.AddChildObject(fScriptNodes[aScript.ScriptType], aScript.Name, aScript);
          AddMessage(Format('Loading %s ...', [aScript.Name]));
        end;
      aNode := aNode.NextSibling;
    end;
  tvScripts.AlphaSort(True);
end;

procedure TfrmMain.acUnloadScriptsExecute(Sender: TObject);
begin
  tvScripts.Items.Clear;
  while fScripts.Count > 0 do
    begin
      TScript(fScripts[0]).Free;
      fScripts.Delete(0);
    end;
end;

procedure TfrmMain.acBuildSQLScriptExecute(Sender: TObject);
var
  i: integer;
  aStr: string;
  aCols: TStringList;
  aVals: TStringList;

  function ViewName: string;
  begin
    (*
    if edtViewName.Text = '' then
      if cbxFile.ItemIndex > -1 then
        Result := TFMFile(cbxFile.Items.Objects[cbxFile.ItemIndex]).Name
      else
        Result := 'UNKNOWN_VIEW'
    else
      Result := edtViewName.Text;
    *)
  end;

  function WhereClause: string;
  begin
    (*
    if edtWhereClause.Text = '' then
      Result := ''
    else
      Result := ' WHERE ' + edtWhereClause.Text;
    *)
  end;

begin
  //case TScriptType(cbxCommandType.ItemIndex) of
  (*
  case fCurrentScript.ScriptType of
    stQuery:
      begin
        aStr := 'SELECT %s FROM %s WHERE ID = :P0';
        aCols := TStringList.Create;
        for i := 0 to fFrames.Count - 1 do
          aCols.Add(TfraFMField(fFrames[i]).getTag);
        memSQL.Text := Format(aStr, [CommaList(aCols), ViewName]);
      end;
    stInsert:
      begin
        aStr := 'INSERT INTO %s (%s) VALUES (%s)';
        aCols := TStringList.Create;
        for i := 0 to fFrames.Count - 1 do
          aCols.Add(TfraFMField(fFrames[i]).getTag);
        memSQL.Text := Format(aStr, [ViewName, CommaList(aCols), ParamList(aCols.Count)]);
      end;
    stUpdate:
      begin
        aStr := 'UPDATE %s SET %s%s';
        aCols := TStringList.Create;
        for i := 0 to fFrames.Count - 1 do
          aCols.Add(TfraFMField(fFrames[i]).getTag);
        memSQL.Text := Format(aStr, [ViewName, ValueList(aCols), WhereClause]);
      end;
    stDelete:
      begin
        memSQL.Text := Format('DELETE FROM %s WHERE ID = :P0', [ViewName]);
      end;
  end;
  *)
end;

function TfrmMain.CommaList(aList: TStringList): string;
var
  i: integer;
begin
  Result := '';
  for i := 0 to aList.Count - 1 do
    if Length(Result) > 0 then
      Result := Format('%s, %s', [Result, aList[i]])
    else
      Result := aList[i];
end;

function TfrmMain.ParamList(aCount: integer): string;
var
  i: integer;
begin
  Result := '';
  for i := 0 to aCount - 1 do
    if i > 0 then
      Result := Format('%s, :P%d', [Result, i])
    else
      Result := Format(':P%d', [i]);
end;

function TfrmMain.ValueList(aList: TStringList): string;
var
  i: integer;
begin
  Result := '';
  for i := 0 to aList.Count - 1 do
    if Length(Result) > 0 then
      Result := Format('%s, %s = :P%d', [Result, aList[i], i + 1])
    else
      Result := Format('%s = :P%d', [aList[i], i + 1]);
end;

procedure TfrmMain.acAddFieldExecute(Sender: TObject);
var
  aNewCol: TScriptColumn;
begin
  aNewCol := NewColumn;
  if Assigned(aNewCol) then
    with lvColumns.Items.Add do
      begin
        Data := aNewCol;
        Selected := True;
        Focused := True;
        acRefreshListView.Execute;
      end;
end;

procedure TfrmMain.acDelFieldExecute(Sender: TObject);
begin
  if lvColumns.Selected <> nil then
    begin
      TScriptColumn(lvColumns.Selected.Data).Free;
      lvColumns.Selected.Delete;
    end;
end;

procedure TfrmMain.acMoveUpExecute(Sender: TObject);
var
  aTempCol: Pointer;
  aIndex: integer;
begin
  if lvColumns.Selected <> nil then
    if lvColumns.Selected.Index > 0 then
      begin
        aIndex := lvColumns.Selected.Index;
        aTempCol := lvColumns.Selected.Data;
        lvColumns.Items[aIndex].Data := lvColumns.Items[aIndex - 1].Data;
        lvColumns.Items[aIndex - 1].Data := aTempCol;
        lvColumns.Selected := lvColumns.Items[aIndex - 1];
        lvColumns.Selected.Focused := True;
        acRefreshListView.Execute;
      end;
end;

procedure TfrmMain.acMoveDownExecute(Sender: TObject);
var
  aTempCol: Pointer;
  aIndex: integer;
begin
  if lvColumns.Selected <> nil then
    if lvColumns.Selected.Index < (lvColumns.Items.Count - 1) then
      begin
        aIndex := lvColumns.Selected.Index;
        aTempCol := lvColumns.Selected.Data;
        lvColumns.Items[aIndex].Data := lvColumns.Items[aIndex + 1].Data;
        lvColumns.Items[aIndex + 1].Data := aTempCol;
        lvColumns.Selected := lvColumns.Items[aIndex + 1];
        lvColumns.Selected.Focused := True;
        acRefreshListView.Execute;
      end;
end;

procedure TfrmMain.acNewCommandExecute(Sender: TObject);
var
  aCmdName: string;
  aScript: TScript;
  aScriptType: TScriptType;
  i: integer;
begin
  aScriptType := TScriptType(TMenuItem(Sender).Tag);

  if InputQuery('New ' + SCRIPT_TYPE_NAME[aScriptType] + ' Script', SCRIPT_TYPE_NAME[aScriptType] + ' Name:', aCmdName) then
    if aCmdName <> '' then
      begin
        for i := 0 to fScripts.Count - 1 do
          if TScript(fScripts[i]).Name = aCmdName then
            begin
              MessageDlg('That script already exists!', mtError, [mbOk], 0);
              Exit;
            end;
        acUnloadForm.Execute;
        fCurrentScript := NewScript(fXMLDocument, aCmdName, aScriptType);
        if Assigned(fCurrentScript) then
          begin
            fScripts.Add(fCurrentScript);
            tvScripts.Items.AddChildObject(fScriptNodes[fCurrentScript.ScriptType], fCurrentScript.Name, fCurrentScript).Selected := True;
            fScriptNodes[fCurrentScript.ScriptType].AlphaSort;
          end;
      end
    else
      MessageDlg('Script name required.', mtError, [mbOk], 0);
end;

procedure TfrmMain.acDeleteCommandExecute(Sender: TObject);
begin
  if MessageDlg('Are you sure you want to delete ''' + fCurrentScript.Name + '''?', mtConfirmation, [mbYes, mbNo, mbCancel], 0) = mrYes then
    begin
      fXMLDocument.DocumentElement.ChildNodes.Remove(fCurrentScript.XMLNode);
      fXMLDocument.SaveToFile(COMMAND_FILE_NAME);
      fScripts.Delete(fScripts.IndexOf(fCurrentScript));
      FreeAndNil(fCurrentScript);
      tvScripts.Selected.Delete;
      acUnloadForm.Execute;
    end;
end;

procedure TfrmMain.acBuildInitializationFileExecute(Sender: TObject);
var
  i: integer;
  aCMDFile: string;
  aXMLFile: IXMLDocument;
  aNode: IXMLNode;
  aCMD: TScript;
begin
  (*
  with NewXMLDocument do
    begin
      Active := True;
      DocumentElement := AddChild('COMMANDS');
      for i := 0 to cbxCommands.Items.Count - 1 do
        begin
          aCMD := TScript(cbxCommands.Items.Objects[i]);
          aNode := DocumentElement.AddChild('COMMAND');
          aNode.ChildValues['NAME'] := aCMD.Name;
          aNode.ChildValues['SQL'] := aCMD.XMLNode.ChildValues['SQLTEXT'];
        end;
      with TStringList.Create do
        try
          Text := FormatXMLData(XML.Text);
          SaveToFile(EXPORT_FILE_NAME);
          ShowMessageFmt('Commands exported to %s', [EXPORT_FILE_NAME]);
        finally
          Free;
        end;
    end;
  *)
end;

procedure TfrmMain.acInstallThisCommandExecute(Sender: TObject);
begin
  InstallOneScript(fCurrentScript);
end;

procedure TfrmMain.acInstallCommandsToVistAExecute(Sender: TObject);
var
  i: integer;
  aCMD: TScript;
  aNode: IXMLNode;
  aText: TStringList;
begin
  case MessageDlg('Remove all existing commands first?', mtConfirmation, [mbYes, mbNo, mbCancel], 0) of
    mrYes: fVistABroker.CallServer(['DELALL'], nil);
    mrCancel: Exit;
  end;

  for i := 0 to fScripts.Count - 1 do
    InstallOneScript(TScript(fScripts[i]));
end;

procedure TfrmMain.acReNameScriptExecute(Sender: TObject);
var
  x: string;
begin
  (*
  x := fCurrentScript.Name;
  if InputQuery('Rename Command', 'New Name:', x) then
    if fCurrentScript.Rename(x) then
      begin
        cbxCommands.Items[cbxCommands.ItemIndex] := x;
        cbxCommands.ItemIndex := cbxCommands.Items.IndexOfObject(fCurrentScript);
      end;
  *)
end;

procedure TfrmMain.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  fVistABroker := NewBroker(Self);
  fVistABroker.ConnectToServer;

  if fVistABroker.Connected then
    acInstallCommandsToVistA.Caption := Format('Install All Commands on ''%s (%d)'' ...', [fVistABroker.Server, fVistABroker.ListenerPort])
  else
    acInstallCommandsToVistA.Caption := 'Can''t install - Not Connected';

  ShowSplashScreen;

  acInitialize.Execute;

  Application.BringToFront;
  BringToFront;
  HideSplashScreen;
end;

procedure TfrmMain.acConvertItExecute(Sender: TObject);
var
  aNode: IXMLNode;
  aFra: TfraFMField;
  i, j: integer;
  aName: string;
  aType: TScriptType;
  aFMType: TFMFieldType;
  aNewXMLDocument: IXMLDocument;
  aNewXMLNode: IXMLNode;
  aNewColNode: IXMLNode;
begin
  MessageDlg('Removed from access', mtInformation, [mbOk], 0);
  Exit;
  aNewXMLDocument := NewXMLDocument;

  aNewXMLDocument.DocumentElement := aNewXMLDocument.AddChild('SCRIPTS');

  for j := 0 to fScripts.Count - 1 do
    with TScript(fScripts[j]) do
      try
        //ShowMessage('Before: ' + #13 + XMLNode.XML);

        aName := Name;
        aType := ScriptType;

        //XMLNode.ChildNodes.Clear;
        //XMLNode.AttributeNodes.Clear;

        aNewXMLNode := aNewXMLDocument.DocumentElement.AddChild('SCRIPT');

        aNewXMLNode.Attributes['NAME'] := Name;
        aNewXMLNode.Attributes['TYPE'] := ScriptType;

        aNewXMLNode.ChildValues['COMMENT'] := XMLNode.Attributes['COMMENT'];
        aNewXMLNode.ChildValues['FM_FILE'] := XMLNode.Attributes['FMFILE'];
        aNewXMLNode.ChildValues['FM_ROOT'] := XMLNode.Attributes['FMROOT'];
        aNewXMLNode.ChildValues['M_EXECUTE'] := XMLNode.Attributes['ROUTINE'];
        aNewXMLNode.ChildValues['M_WHERE'] := ''; {Doesn't exist in the old style}

        aNode := XMLnode.ChildNodes.FindNode('COLUMNS');
        if Assigned(aNode) then
          begin
            aNewColNode := aNewXMLNode.AddChild('COLUMNS');
            aNode := aNode.ChildNodes.First;
            while Assigned(aNode) do
              begin
                with aNewColNode.AddChild('COLUMN') do
                  begin
                    Attributes['TAG'] := aNode.Attributes['TAG'];
                    ChildValues['FM_FIELD'] := aNode.Attributes['FMFIELD'];
                    for aFMType := Low(TFMFieldType) to High(TFMFieldType) do
                      if pos(FIELD_TYPE[aFMType], aNode.Attributes['DATATYPE']) > 0 then
                        ChildValues['FM_DATATYPE'] := aFMType;
                    ChildValues['INTERNAL_FORMAT'] := (aNode.Attributes['FORMAT'] = '0');
                    ChildValues['COMMENT'] := aNode.Attributes['COMMENT'];
                  end;
                aNode := aNode.NextSibling;
              end;
          end;
        (*
        aNode := ;
        for i := 0 to fFrames.Count - 1 do
          begin
            aFra := TfraFMField(fFrames[i]);
            with aNode.AddChild('COLUMN') do
              begin
                ChildValues['FMFIELD'] := aFra.getFMField;
                ChildValues['TAG'] := aFra.getTag;
                ChildValues['FORMAT'] := aFra.getFormat;
                ChildValues['DATATYPE'] := aFra.getDataType;
                ChildValues['COMMENT'] := aFra.getComment;
              end;
          end;
        *)
        //ShowMessage('After: ' + #13 + FormatXMLData(aNewXMLNode.XML));

        (*
        aNode := fCurrentScript.XMLNode.AddChild('FMSCRIPT');
        for i := 0 to memFileman.Lines.Count - 1 do
          aNode.ChildValues[Format('X%0.4d', [i])] := memFileman.Lines[i];
        ChildValues['SQLTEXT'] := memSQL.Text;
        ChildValues['SQLWHERE'] := edtWhereClause.Text;
        fXMLDocument.SaveToFile(COMMAND_FILE_NAME);
        *)
      except
        on e: exception do
          MessageDlg('Error saving script:' + e.Message, mtError, [mbOk], 0);
      end;
  aNewXMLDocument.SaveToFile('.\joey.xml');
end;

procedure TfrmMain.acCopyToClipboardExecute(Sender: TObject);
var
  aLst: TStringList;
begin
  aLst := TStringList.Create;
  try
    fCurrentScript.GetVistAScript(aLst);
    if MessageDlg('The following text will be placed on the clipboard' + #13 + #13 +
      aLst.Text, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      with Clipboard do
        try
          Open;
          Clear;
          AsText := aLst.Text;
          Close;
        except
          ShowMessage('oops');
        end;
  finally
    FreeAndNil(aLst);
  end;
end;

procedure TfrmMain.acRefreshListViewExecute(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to lvColumns.Items.Count - 1 do
    if Assigned(lvColumns.Items[i].Data) then
      with TScriptColumn(lvColumns.Items[i].Data) do
        begin
          lvColumns.Items[i].SubItems.Clear;
          lvColumns.Items[i].Caption := FMFieldNumber;
          lvColumns.Items[i].SubItems.Add(XMLTag);
          if FInternalFormat then
            lvColumns.Items[i].SubItems.Add('Internal')
          else
            lvColumns.Items[i].SubItems.Add('External');
          lvColumns.Items[i].SubItems.Add(FIELD_TYPE_NAME[FMFieldType]);
          lvColumns.Items[i].SubItems.Add(Comment);
        end;
end;

procedure TfrmMain.acEditFieldExecute(Sender: TObject);
begin
  if lvColumns.Selected <> nil then
    if EditColumn(TScriptColumn(lvColumns.Selected.Data)) then
      acRefreshListView.Execute;
end;

procedure TfrmMain.acViewFilemanScriptExecute(Sender: TObject);
var
  aLst: TStringList;
begin
  aLst := TStringList.Create;
  try
    fCurrentScript.GetVistAScript(aLst);
    ShowMessage(aLst.Text);
  finally
    FreeAndNil(aLst);
  end;
end;

procedure TfrmMain.btnCloseClick(Sender: TObject);
begin
  gbxInstalling.Visible := False;
end;

procedure TfrmMain.cbxFileKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    begin
      cbxFile.ItemIndex := -1;
      acSelectFile.Execute;
    end;
end;

procedure TfrmMain.tvScriptsDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  if (Sender = Source) and (TTreeView(Source).GetNodeAt(X, Y) <> nil) then
    Accept := (TTreeView(Source).GetNodeAt(X, Y).Data = nil) and
      (TTreeView(Source).GetNodeAt(X, Y) <> tvScripts.Selected.Parent) and
      (TTreeView(Source).GetNodeAt(X, Y) <> tvScripts.Items.GetFirstNode);
end;

procedure TfrmMain.tvScriptsEdited(Sender: TObject; Node: TTreeNode; var S: string);
begin
  if not fCurrentScript.Rename(S) then
    s := fCurrentScript.Name;

  lblScriptDefinition.Caption := Format('Script ''%s'' Definition', [fCurrentScript.Name]);
end;

procedure TfrmMain.tvScriptsDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  aDropNode: TTreeNode;
  aScript: TScript;
  aMsg: string;
  aType: TScriptType;
begin
  aDropNode := tvScripts.GetNodeAt(X, Y);
  aScript := TScript(tvScripts.Selected.Data);
  for aType := Low(TScriptType) to High(TScriptType) do
    if fScriptNodes[aType] = aDropNode then
      Break;

  aMsg := Format('Change script ''%s'' to command type ''%s''?', [aScript.Name, SCRIPT_TYPE[aType]]);

  if MessageDlg(aMsg, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      aScript.ScriptType := aType;
      tvScripts.Selected.MoveTo(aDropNode, naAddChild);
      aDropNode.AlphaSort;
    end;
end;

procedure TfrmMain.tvScriptsGetImageIndex(Sender: TObject; Node: TTreeNode);
begin
  if Node.Data <> nil then
    with TScript(Node.Data) do
      begin
        if (ScriptType = stQuery) and (StrToIntDef(Cached, 0) = 1) then
          begin
            Node.ImageIndex := 13;
            Node.SelectedIndex := 13;
          end
        else
          begin
            Node.ImageIndex := 11;
            Node.SelectedIndex := 11;
          end
      end
  else if Node.Expanded then
    begin
      Node.ImageIndex := 12;
      Node.SelectedIndex := 12;
    end
  else
    begin
      Node.ImageIndex := 9;
      Node.SelectedIndex := 9;
    end;
end;

procedure TfrmMain.ToolButton7Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.ToolButton8Click(Sender: TObject);
begin
  AboutDlg.Execute;
end;

end.

