unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, ActnList, ActnMan, ActnColorMaps,
  ActnMenus, ToolWin, ActnCtrls, Spin, uDevices, uPatients,
  XPStyleActnCtrls, uHomePage, uScenario, CheckLst, uServers;

type
  TfMain = class(TForm)
    sbMain: TStatusBar;
    amMainFormActions: TActionManager;
    sdPatientDeviceSave: TSaveDialog;
    actFileNewPatient: TAction;
    actEditDevices: TAction;
    pcMainForm: TPageControl;
    tsHome: TTabSheet;
    tsPatients: TTabSheet;
    tsDevices: TTabSheet;
    pnlDevices: TPanel;
    Label3: TLabel;
    Bevel2: TBevel;
    Label5: TLabel;
    tvDevices: TTreeView;
    pnlPatients: TPanel;
    Label1: TLabel;
    Bevel1: TBevel;
    Label2: TLabel;
    lvActivePatients: TListView;
    btnAddNewPatient: TButton;
    btnLoadPatients: TButton;
    btnSavePatients: TButton;
    tsProperties: TTabSheet;
    fraHomePage1: TfraHomePage;
    Panel1: TPanel;
    Label4: TLabel;
    Bevel3: TBevel;
    Label6: TLabel;
    edtDeviceDescription: TEdit;
    Label7: TLabel;
    edtObservationRequestSegment: TEdit;
    btnEditObsTypes: TButton;
    btnSaveSettings: TButton;
    Label8: TLabel;
    edtPatientFilename: TEdit;
    Label9: TLabel;
    edtDeviceFilename: TEdit;
    Label10: TLabel;
    edtScenarioFilename: TEdit;
    odPatientDeviceFile: TOpenDialog;
    tsScenarios: TTabSheet;
    pnlTop: TPanel;
    Label11: TLabel;
    cbSelectedScenario: TComboBox;
    pnlCenter: TPanel;
    pnlLeftCenter: TPanel;
    Label12: TLabel;
    pnlCenterCenter: TPanel;
    lblDevices: TLabel;
    lvDevices: TListView;
    pnlCenterLeft: TPanel;
    btnNewScenario: TButton;
    Label13: TLabel;
    Bevel4: TBevel;
    btnLoadScenarios: TButton;
    btnSaveScenarios: TButton;
    Label14: TLabel;
    Bevel5: TBevel;
    Label15: TLabel;
    lblPatientName: TLabel;
    clbPatients: TCheckListBox;
    Label16: TLabel;
    edtFieldSeperator: TEdit;
    Label17: TLabel;
    edtEncodingCharacters: TEdit;
    Label18: TLabel;
    edtSendingApplication: TEdit;
    Label19: TLabel;
    edtSendingFacility: TEdit;
    Label20: TLabel;
    edtReceivingApplication: TEdit;
    Label21: TLabel;
    edtReceivingFacility: TEdit;
    Label22: TLabel;
    edtMessageType: TEdit;
    Label23: TLabel;
    edtEventType: TEdit;
    Label24: TLabel;
    edtMessageControlID: TEdit;
    Label25: TLabel;
    edtProcessingID: TEdit;
    Label26: TLabel;
    edtVersionID: TEdit;
    cbSendAllObsAtOnce: TCheckBox;
    seDeviceFrequency: TSpinEdit;
    Label27: TLabel;
    Bevel6: TBevel;
    Label28: TLabel;
    edtCommonOrderSegment: TEdit;
    Label29: TLabel;
    edtServerFilename: TEdit;
    btnLoadDevices: TButton;
    btnNewDevice: TButton;
    btnSaveDevices: TButton;
    btnEditServers: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnSavePatientsClick(Sender: TObject);
    procedure btnLoadPatientsClick(Sender: TObject);
    procedure actFileNewPatientExecute(Sender: TObject);
    procedure btnNewDeviceClick(Sender: TObject);
    procedure btnSaveDevicesClick(Sender: TObject);
    procedure btnLoadDevicesClick(Sender: TObject);
    procedure tvDevicesDblClick(Sender: TObject);
    procedure tvDevicesClick(Sender: TObject);
    procedure DeviceDataChange(Sender: TObject);
    procedure btnSaveSettingsClick(Sender: TObject);
    procedure tsScenariosShow(Sender: TObject);
    procedure btnNewScenarioClick(Sender: TObject);
    procedure cbSelectedScenarioSelect(Sender: TObject);
    procedure btnLoadScenariosClick(Sender: TObject);
    procedure btnSaveScenariosClick(Sender: TObject);
    procedure clbPatientsClickCheck(Sender: TObject);
    procedure clbPatientsClick(Sender: TObject);
    procedure lvDevicesClick(Sender: TObject);
    procedure btnEditObsTypesClick(Sender: TObject);
    procedure cbSendAllObsAtOnceClick(Sender: TObject);
    procedure fraHomePage1btnStartClick(Sender: TObject);
    procedure btnEditServersClick(Sender: TObject);
  private
    { Private declarations }
    FPatients: TPatientList;
    FDevices: TDeviceList;
    FScenarios: TScenarioList;
    FServers: TServerList;

    FSelectedDevice: TDevice;
    FSelectedScenario: TScenario;
    FSelectedBed: TBed;
    
    FPatientFilename: string;
    FDeviceFilename: string;
    FScenarioFilename: string;
    FServerFilename: string;
    FPathName: string;
    procedure AddToPtList(AItem: TListItem; APatient: TPatient);
    procedure AddToDevTree(ANode: TTreeNode; ADevice: TDevice);

    procedure DisableDeviceOnChangeEvents;
    procedure EnableDeviceOnChangeEvents;
    procedure DisableDeviceFields;
    procedure EnableDeviceFields;
    procedure RepaintDeviceTree;
    procedure RepaintDeviceFields;
    procedure ReloadScenarios;
  public
    { Public declarations }
  end;

var
  fMain: TfMain;

implementation

uses
  IniFiles, uAddEdtPatient, uAddEdtDevice, SyncObjs, uAddEdtServer;

const
  INIFILENAME = 'HL7Generator.ini';
  PATIENTS = 'patients';
  FILENAME = 'filename';
  DEVICES = 'devices';
  SCENARIOS = 'scenarios';
  SERVERS = 'servers';


var
  CritSec: TCriticalSection;

{$R *.dfm}

procedure TfMain.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  I: Integer;
  Item: TListItem;
begin
  FPatients := TPatientList.Create(TPatient);
  FDevices := TDeviceList.Create(TDevice);
  FScenarios := TScenarioList.Create(TScenario);
  FServers := TServerList.Create(TServer);

  fraHomePage1.PatientList := FPatients;
  fraHomePage1.DeviceList := FDevices;
  fraHomePage1.ScenarioList := FScenarios;

  FPathName := IncludeTrailingPathDelimiter(ExtractFilePath(Application.ExeName));

  if FileExists(FPathName + INIFILENAME) then
  begin
    IniFile := TIniFile.Create(FPathName + INIFILENAME);
    try
      FPatientFilename := IniFile.ReadString(PATIENTS,FILENAME,'');

      if FileExists(FPatientFilename) then
      begin
        FPatients.Load(FPatientFilename);
        lvActivePatients.Items.Clear;
        lvActivePatients.Items.BeginUpdate;
        try
          lvActivePatients.Items.Clear;
          for I := 0 to FPatients.Count - 1 do
          begin
            Item := lvActivePatients.Items.Add;
            AddToPtList(Item, FPatients[I]);
          end;
        finally
          lvActivePatients.Items.EndUpdate;
        end;
        edtPatientFilename.Text := FPatientFilename;
      end;

      FDeviceFilename := IniFile.ReadString(DEVICES,FILENAME, '');
      if FileExists(FDeviceFilename) then
      begin
        FDevices.Load(FDeviceFilename);
        RepaintDeviceTree;
        edtDeviceFilename.Text := FDeviceFilename;
      end;

      FScenarioFilename := IniFile.ReadString(SCENARIOS,FILENAME,'');

      if FileExists(FScenarioFilename) then
      begin
        FScenarios.Load(FScenarioFilename, FPatients, FDevices);
        ReloadScenarios;
        edtScenarioFilename.Text := FScenarioFilename;
      end;

      FServerFilename := IniFile.ReadString(SERVERS, FILENAME,'');
      if FileExists(FServerFilename) then
      begin
        FServers.Load(FServerFilename);
      end;
      fraHomePage1.ServerList := FServers;
      edtServerFilename.Text := FServerFilename;

    finally
      FreeAndNil(IniFile);
    end;
  end;

  fraHomePage1.sbMessagesSent.DoubleBuffered := true;
end;

procedure TfMain.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FScenarios);
  FreeAndNil(FDevices);
  FreeAndNil(FPatients);
end;

procedure TfMain.fraHomePage1btnStartClick(Sender: TObject);
begin
  fraHomePage1.btnStartClick(Sender);

end;

procedure TfMain.lvDevicesClick(Sender: TObject);
var
  I: Integer;
begin
  //
  if assigned(FSelectedBed) then
  begin
    FSelectedBed.Devices.Clear;
    for I := 0 to lvDevices.Items.Count - 1 do
    begin
      if lvDevices.Items[I].Checked then
        FSelectedBed.Devices.Add(TDevice(lvDevices.Items[I].Data));
    end;
  end;
end;

procedure TfMain.btnSavePatientsClick(Sender: TObject);
begin
  sdPatientDeviceSave.Title := 'Please enter the name of a TEST patient file...';
  if sdPatientDeviceSave.Execute then
  begin
    FPatients.Save(sdPatientDeviceSave.FileName);
  end;
end;

procedure TfMain.btnLoadPatientsClick(Sender: TObject);
var
  I: Integer;
  Item: TListItem;
begin
  odPatientDeviceFile.Title := 'Please enter the name of a TEST patient file...';
  if odPatientDeviceFile.Execute then
  begin
    FPatients.Load(odPatientDeviceFile.FileName);
    lvActivePatients.Items.Clear;
    lvActivePatients.Items.BeginUpdate;
    try
      lvActivePatients.Items.Clear;
      for I := 0 to FPatients.Count - 1 do
      begin
        Item := lvActivePatients.Items.Add;
        AddToPtList(Item, FPatients[I]);
      end;
    finally
      lvActivePatients.Items.EndUpdate;
    end;
  end;
end;

procedure TfMain.AddToPtList(AItem: TListItem; APatient: TPatient);
begin
  AItem.Data := APatient;
  AItem.Caption := APatient.LastName;
  AItem.SubItems.Add(APatient.FirstName);
  AItem.SubItems.Add(APatient.SSAN);
end;

procedure TfMain.actFileNewPatientExecute(Sender: TObject);
var
  PatientFrm: TfPatientEditor;
  Patient: TPatient;
  Item: TListItem;
begin
  PatientFrm := TfPatientEditor.Create(nil);
  try
    if assigned(lvActivePatients.Selected) then
      Patient := TPatient(lvActivePatients.Selected.Data)
    else
      Patient := FPatients.Add;

    PatientFrm.edtFirstName.Text := Patient.FirstName;
    PatientFrm.edtMiddleName.Text := Patient.MiddleName;
    PatientFrm.edtLastName.Text := Patient.LastName;
    PatientFrm.edtSSN.Text := Patient.SSAN;
    PatientFrm.edtMMN.Text := Patient.MothersMaidenName;
    PatientFrm.edtDOB.Text := FormatDateTime('mm/dd/yyyy', Patient.DateOfBirth);
    PatientFrm.cbGender.ItemIndex := PatientFrm.cbGender.Items.IndexOf(Patient.Sex);
    PatientFrm.edtAlias.Text := Patient.Alias;
    PatientFrm.cbRace.ItemIndex := PatientFrm.cbRace.Items.IndexOf(Patient.Race);
    PatientFrm.edtStreet1.Text := Patient.Address.Address1;
    PatientFrm.edtStreet2.Text := Patient.Address.Address2;
    PatientFrm.edtCity.Text := Patient.Address.City;
    PatientFrm.cbState.ItemIndex := PatientFrm.cbState.Items.IndexOf(Patient.Address.State);
    PatientFrm.edtZip.Text := Patient.Address.Zip;

    if PatientFrm.ShowModal = mrOK then
    begin
      Patient.FirstName := PatientFrm.edtFirstName.Text;
      Patient.MiddleName := PatientFrm.edtMiddleName.Text;
      Patient.LastName := PatientFrm.edtLastName.Text;
      Patient.SSAN := PatientFrm.edtSSN.Text;
      Patient.MothersMaidenName := PatientFrm.edtMMN.Text;
      Patient.DateOfBirth := StrToDate(PatientFrm.edtDOB.Text);
      Patient.Sex := PatientFrm.cbGender.Text;
      Patient.Alias := PatientFrm.edtAlias.Text;
      Patient.Race := PatientFrm.cbRace.Text;
      Patient.Address.Address1 := PatientFrm.edtStreet1.Text;
      Patient.Address.Address2 := PatientFrm.edtStreet2.Text;
      Patient.Address.City := PatientFrm.edtCity.Text;
      Patient.Address.State := PatientFrm.cbState.Text;
      Patient.Address.Zip := PatientFrm.edtZip.Text;

      if not assigned(lvActivePatients.Selected) then
      begin
        Item := lvActivePatients.Items.Add;
        AddToPtList(Item, Patient);
      end;
    end
    else
    begin
      if not assigned(lvActivePatients.Selected) then
        FPatients.Delete(Patient.Index);
    end;
  finally
    FreeAndNil(PatientFrm);
  end;
end;

procedure TfMain.btnNewDeviceClick(Sender: TObject);
var
  Node: TTreeNode;
  Device: TDevice;
  DeviceName: string;
begin
  if InputQuery('New Device Name...', 'Please enter a name for the new device:', DeviceName) then
  begin
    try
      Device := FDevices.Add(DeviceName);
      Node := tvDevices.Items.AddChild(nil, Device.Description);
      Node.Data := Device;
      RepaintDeviceTree;
    except on E:EDeviceNameException do
      ShowMessage(E.Message);
    end;
  end;
end;

procedure TfMain.btnSaveDevicesClick(Sender: TObject);
begin
  sdPatientDeviceSave.Title := 'Please enter the name of a TEST device file...';
  if sdPatientDeviceSave.Execute then
  begin
    FDevices.Save(sdPatientDeviceSave.FileName);
  end;
end;

procedure TfMain.btnEditObsTypesClick(Sender: TObject);
begin
  tvDevicesDblClick(Sender);
end;

procedure TfMain.btnEditServersClick(Sender: TObject);
var
  frmAddEdtServer: TfrmAddEditServers;
begin
  frmAddEdtServer := TfrmAddEditServers.Create(nil);
  try
    frmAddEdtServer.Servers := FServers;
    if frmAddEdtServer.ShowModal = mrOK then
    begin
      if Trim(edtServerFilename.Text) = '' then
        edtServerFilename.Text := InputBox('Server list', 'Please enter a filename for your server list',
          'servers.xml');
      FServers.Save(edtServerFilename.Text);
      FraHomePage1.RefreshServerList;
    end;
  finally
    FreeAndNil(frmAddEdtServer);
  end;
end;

procedure TfMain.btnLoadDevicesClick(Sender: TObject);
begin
  odPatientDeviceFile.Title := 'Please enter the name of a TEST device file...';
  if odPatientDeviceFile.Execute then
  begin
    FDevices.Load(odPatientDeviceFile.FileName);
    RepaintDeviceTree;
  end;
end;

procedure TfMain.AddToDevTree(ANode: TTreeNode; ADevice: TDevice);
var
  tv: TTreeView;
  Node: TTreeNode;
  I: Integer;
begin
  ANode.Data := ADevice;
  
  tv := TTreeView(ANode.TreeView);
  for I := 0 to ADevice.Observations.Count - 1 do
  begin
    Node := tv.Items.AddChild(ANode, ADevice.Observations[I].Description);
    Node.Data := ADevice.Observations[I];
  end;
end;

procedure TfMain.tvDevicesDblClick(Sender: TObject);
var
  fDeviceEditor: TfDeviceEditor;
begin
  if (assigned(tvDevices.Selected)) and (TObject(tvDevices.Selected.Data) is TDevice) then
  begin
    fDeviceEditor := TfDeviceEditor.Create(nil);
    try
      fDeviceEditor.Device := TDevice(tvDevices.Selected.Data);
      fDeviceEditor.ShowModal;
      RepaintDeviceTree;
    finally
      FreeAndNil(fDeviceEditor);
    end;
  end;
end;

procedure TfMain.tvDevicesClick(Sender: TObject);
begin
  if (assigned(tvDevices.Selected)) and (TObject(tvDevices.Selected.Data) is TDevice) then
  begin
    RepaintDeviceFields;
  end
  else
    DisableDeviceFields;
end;

procedure TfMain.DisableDeviceOnChangeEvents;
begin
  edtDeviceDescription.OnExit := nil;

  edtFieldSeperator.OnExit := nil;
  edtEncodingCharacters.OnExit := nil;
  edtSendingApplication.OnExit := nil;
  edtSendingFacility.OnExit := nil;
  edtReceivingApplication.OnExit := nil;
  edtReceivingFacility.OnExit := nil;
  edtMessageType.OnExit := nil;
  edtMessageControlID.OnExit := nil;
  edtProcessingID.OnExit := nil;
  edtVersionID.OnExit := nil;
  edtObservationRequestSegment.OnExit := nil;


  edtObservationRequestSegment.OnExit := nil;
end;

procedure TfMain.EnableDeviceOnChangeEvents;
begin
  edtDeviceDescription.OnExit := DeviceDataChange;

  edtFieldSeperator.OnExit := DeviceDataChange;
  edtEncodingCharacters.OnExit := DeviceDataChange;
  edtSendingApplication.OnExit := DeviceDataChange;
  edtSendingFacility.OnExit := DeviceDataChange;
  edtReceivingApplication.OnExit := DeviceDataChange;
  edtReceivingFacility.OnExit := DeviceDataChange;
  edtMessageType.OnExit := DeviceDataChange;
  edtMessageControlID.OnExit := DeviceDataChange;
  edtProcessingID.OnExit := DeviceDataChange;
  edtVersionID.OnExit := DeviceDataChange;
  edtObservationRequestSegment.OnExit := DeviceDataChange;

  edtObservationRequestSegment.OnExit := DeviceDataChange;
end;

procedure TfMain.DisableDeviceFields;
begin
  edtDeviceDescription.Enabled := false;
  btnEditObsTypes.Enabled := false;

  edtFieldSeperator.Enabled := False;
  edtEncodingCharacters.Enabled := False;
  edtSendingApplication.Enabled := False;
  edtSendingFacility.Enabled := False;
  edtReceivingApplication.Enabled := False;
  edtReceivingFacility.Enabled := False;
  edtMessageType.Enabled := False;
  edtMessageControlID.Enabled := False;
  edtProcessingID.Enabled := False;
  edtVersionID.Enabled := False;
  edtObservationRequestSegment.Enabled := False;


  edtObservationRequestSegment.Enabled := false;
end;

procedure TfMain.EnableDeviceFields;
begin
  edtDeviceDescription.Enabled := true;

  edtFieldSeperator.Enabled := True;
  edtEncodingCharacters.Enabled := True;
  edtSendingApplication.Enabled := True;
  edtSendingFacility.Enabled := True;
  edtReceivingApplication.Enabled := True;
  edtReceivingFacility.Enabled := True;
  edtMessageType.Enabled := True;
  edtMessageControlID.Enabled := True;
  edtProcessingID.Enabled := True;
  edtVersionID.Enabled := True;
  edtObservationRequestSegment.Enabled := True;

  edtObservationRequestSegment.Enabled := true;
end;

procedure TfMain.DeviceDataChange(Sender: TObject);
begin
  if assigned(FSelectedDevice) then
  begin
    CritSec.Enter;
    try
      FSelectedDevice.Description := edtDeviceDescription.Text;

      if edtFieldSeperator.Text <> '' then
      begin
        FSelectedDevice.FieldSeperator := edtFieldSeperator.Text[1];
      end;
      FSelectedDevice.EncodingChars := edtEncodingCharacters.Text;
      FSelectedDevice.SendingApplication := edtSendingApplication.Text;
      FSelectedDevice.SendingFacility := edtSendingFacility.Text;
      FSelectedDevice.ReceivingApplication := edtReceivingApplication.Text;
      FSelectedDevice.ReceivingFacility := edtReceivingFacility.Text;
      FSelectedDevice.MessageType := edtMessageType.Text;
      FSelectedDevice.EventType := edtEventType.Text;
      FSelectedDevice.MessageControlID := edtMessageControlID.Text;
      FSelectedDevice.ProcessingCode := edtProcessingID.Text;
      FSelectedDevice.VersionID := edtVersionID.Text;
      FSelectedDevice.OBRSegment := edtObservationRequestSegment.Text;
      FSelectedDevice.ORCSegment := edtCommonOrderSegment.Text;
      FSelectedDevice.SendAllObservationsAtOnce := cbSendAllObsAtOnce.Checked;
      FSelectedDevice.Interval := seDeviceFrequency.Value * 1000;
      RepaintDeviceTree;
    finally
      CritSec.Leave;
    end;
  end;
end;

procedure TfMain.RepaintDeviceFields;
begin
  FSelectedDevice := TDevice(tvDevices.Selected.Data);

  DisableDeviceOnChangeEvents;
  try
    btnEditObsTypes.Enabled := true;
    edtDeviceDescription.Text := FSelectedDevice.Description;
    edtFieldSeperator.Text := FSelectedDevice.FieldSeperator;
    edtEncodingCharacters.Text := FSelectedDevice.EncodingChars;
    edtSendingApplication.Text := FSelectedDevice.SendingApplication;
    edtSendingFacility.Text := FSelectedDevice.SendingFacility;
    edtReceivingApplication.Text := FSelectedDevice.ReceivingApplication;
    edtReceivingFacility.Text := FSelectedDevice.ReceivingFacility;
    edtMessageType.Text := FSelectedDevice.MessageType;
    edtEventType.Text := FSelectedDevice.EventType;
    edtMessageControlID.Text := FSelectedDevice.MessageControlID;
    edtProcessingID.Text := FSelectedDevice.ProcessingCode;
    edtVersionID.Text := FSelectedDevice.VersionID;
    edtObservationRequestSegment.Text := FSelectedDevice.OBRSegment;
    edtCommonOrderSegment.Text := FSelectedDevice.ORCSegment;
    cbSendAllObsAtOnce.Checked := FSelectedDevice.SendAllObservationsAtOnce;
    seDeviceFrequency.Value := FSelectedDevice.Interval div 1000;
  finally
    EnableDeviceOnChangeEvents;
    EnableDeviceFields;
  end;
end;

procedure TfMain.RepaintDeviceTree;
var
  Node: TTreeNode;
  I: Integer;
begin
  tvDevices.Items.BeginUpdate;
  try
    tvDevices.Items.Clear;
    for I := 0 to FDevices.Count - 1 do
    begin
      Node := tvDevices.Items.Add(nil, FDevices[I].Description);
      AddToDevTree(Node, FDevices[I]);
    end;
  finally
    tvDevices.Items.EndUpdate;
  end;
end;

procedure TfMain.btnSaveSettingsClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  IniFile := TIniFile.Create(FPathName + INIFILENAME);
  try
    IniFile.WriteString(PATIENTS, FILENAME, edtPatientFilename.Text);
    IniFile.WriteString(DEVICES, FILENAME, edtDeviceFilename.Text);
    IniFile.WriteString(SCENARIOS, FILENAME, edtScenarioFilename.Text);
    IniFile.WriteString(SERVERS, FILENAME, edtServerFilename.Text);
  finally
    FreeAndNil(IniFile);
  end;
end;

procedure TfMain.tsScenariosShow(Sender: TObject);
var
  I: Integer;
  Item: TListItem;
begin
  if assigned(FPatients) then
  begin
    clbPatients.Clear;
    for I := 0 to FPatients.Count - 1 do
      clbPatients.AddItem(FPatients[I].FullName, FPatients[I]);
  end;

  if assigned(FDevices) then
  begin
    lvDevices.Clear;
    for I := 0 to FDevices.Count - 1 do
    begin
      Item := lvDevices.Items.Add;
      Item.Caption := FDevices[I].Description;
      Item.Data := FDevices[I];
    end;
  end;
end;

procedure TfMain.ReloadScenarios;
var
  I: Integer;
begin
  if assigned(FScenarios) then
  begin
    cbSelectedScenario.Clear;
    fraHomePage1.cbScenario.Clear;
    cbSelectedScenario.Items.BeginUpdate;
    try
      fraHomePage1.cbScenario.Items.BeginUpdate;
      try
        for I := 0 to FScenarios.Count - 1 do
        begin
          cbSelectedScenario.AddItem(FScenarios[I].Ward.Name, FScenarios[I]);
          fraHomePage1.cbScenario.AddItem(FScenarios[I].Ward.Name, FScenarios[I]);
        end;
      finally
        fraHomePage1.cbScenario.Items.EndUpdate;
      end;
    finally
      cbSelectedScenario.Items.EndUpdate;
    end;
  end;

  if cbSelectedScenario.Items.Count > 0 then
  begin
    cbSelectedScenario.ItemIndex := 0;
    fraHomePage1.cbScenario.ItemIndex := 0;
    cbSelectedScenarioSelect(cbSelectedScenario);
    fraHomePage1.cbScenarioSelect(fraHomePage1.cbScenario);
  end;
end;

procedure TfMain.btnNewScenarioClick(Sender: TObject);
var
  ScenarioName: string;
  Scenario: TScenario;
begin
  ScenarioName := '';

  if InputQuery('New Scenario', 'Please enter the name of a new Scenario', ScenarioName) then
  begin
    if Assigned(FScenarios.FindItemName(ScenarioName)) then
    begin
      MessageDlg('Scenario names must be unique.  Please enter a unique scenario name.', mtError, [mbOK], 0);
    end
    else
    begin
      Scenario := FScenarios.Add;
      Scenario.Ward.Name := ScenarioName;
      ReloadScenarios;
    end;
  end;
end;

procedure TfMain.cbSelectedScenarioSelect(Sender: TObject);
var
  I, J: Integer;
begin
  FSelectedScenario := TScenario(cbSelectedScenario.Items.Objects[cbSelectedScenario.ItemIndex]);

  if assigned(FSelectedScenario) then
  begin
    for I := 0 to FSelectedScenario.Ward.Count - 1 do
    begin
      {
        I was kind of surprised to find that the TListView.Items collection
        doesn't have an IndexOfObject() method like TStrings does.  Unfortunately,
        that kind of means that we have to do things the old-fashioned way.
      }
      for J := 0 to clbPatients.Items.Count - 1 do
        clbPatients.Checked[J] := TPatient(clbPatients.Items.Objects[J]).ID = FSelectedScenario.Ward[I].Patient.ID;
    end;
    clbPatients.Enabled := true;
    lvDevices.Enabled := true;
  end
  else
  begin
    clbPatients.Enabled := false;
    lvDevices.Enabled := false;
  end;
end;

procedure TfMain.cbSendAllObsAtOnceClick(Sender: TObject);
begin
  seDeviceFrequency.Enabled := cbSendAllObsAtOnce.Checked;
end;

procedure TfMain.btnLoadScenariosClick(Sender: TObject);
begin
  odPatientDeviceFile.Title := 'Please enter the name of a TEST Scenario file...';
  if odPatientDeviceFile.Execute then
  begin
    FScenarios.Load(odPatientDeviceFile.FileName, FPatients, FDevices);
    ReloadScenarios;
    edtScenarioFilename.Text := odPatientDeviceFile.FileName;
  end;
end;

procedure TfMain.btnSaveScenariosClick(Sender: TObject);
begin
  sdPatientDeviceSave.Title := 'Please enter the name of a TEST Scenario file...';
  if sdPatientDeviceSave.Execute then
  begin
    FScenarios.Save(sdPatientDeviceSave.FileName);
  end;
end;

procedure TfMain.clbPatientsClickCheck(Sender: TObject);
var
  Patient: TPatient;
  I: Integer;
  Item: TListItem;
begin
  Patient := TPatient(clbPatients.Items.Objects[clbPatients.ItemIndex]);
  FSelectedBed := FSelectedScenario.Ward.FindItemByPatient(Patient);

  if clbPatients.Checked[clbPatients.ItemIndex] then
  begin
    if not Assigned(FSelectedBed) then
    begin
      FSelectedBed := FSelectedScenario.Ward.Add;
      FSelectedBed.Patient := Patient;
    end;
    for I := 0 to FSelectedBed.Devices.Count - 1 do
    begin
      Item := lvDevices.FindData(0, FSelectedBed.Devices[I], true, false);
      if Assigned(Item) then
        Item.Checked := true;
    end;
  end
  else
  begin
    if Assigned(FSelectedBed) then
      FSelectedScenario.Ward.Delete(FSelectedBed.Index);
  end;
end;

procedure TfMain.clbPatientsClick(Sender: TObject);
var
  I: Integer;
begin
  if clbPatients.ItemIndex = -1 then
  begin
    FSelectedBed := nil;
  end
  else
  begin
    FSelectedBed := FSelectedScenario.Ward.FindItemByPatient(TPatient(clbPatients.Items.Objects[clbPatients.ItemIndex]));
    if assigned(FSelectedBed) then
    begin
      lvDevices.Enabled := true;

      lblPatientName.Caption := FSelectedBed.Patient.FullName;

      for I := 0 to lvDevices.Items.Count - 1 do
      begin
        lvDevices.Items[I].Checked := FSelectedBed.Devices.IndexOf(TDevice(lvDevices.Items[I].Data)) > -1;
      end;
    end
    else
    begin
      lblPatientName.Caption := '';
      for I := 0 to lvDevices.Items.Count - 1 do
        lvDevices.Items[I].Checked := false;

      lvDevices.Enabled := false;
    end;
  end;
end;

initialization
  CritSec := TCriticalSection.Create;

finalization
  FreeAndNil(CritSec);

end.
