unit uServers;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, uServerList;

type
  TfrmServers = class(TForm)
    lbServers: TListBox;
    lblName: TLabel;
    lblIP: TLabel;
    lblPort: TLabel;
    edtName: TEdit;
    edtIPAddress: TEdit;
    edtPort: TEdit;
    btnAddNewServer: TButton;
    btnOK: TButton;
    btnCancel: TButton;
    btnDeleteSelected: TButton;
    procedure FormShow(Sender: TObject);
    procedure btnDeleteSelectedClick(Sender: TObject);
    procedure btnAddNewServerClick(Sender: TObject);
    procedure lbServersClick(Sender: TObject);
    procedure edtNameExit(Sender: TObject);
    procedure edtIPAddressExit(Sender: TObject);
    procedure edtPortExit(Sender: TObject);
  private
    { Private declarations }
    ActiveItem: TServerItem;
    procedure DeactivateDisplay;
    procedure ActivateDisplay;
  public
    { Public declarations }
    Servers: TServers;
  end;

var
  frmServers: TfrmServers;

implementation

{$R *.dfm}

procedure TfrmServers.ActivateDisplay;
begin
  btnDeleteSelected.Enabled := true;
  edtName.Enabled := true;
  edtIPAddress.Enabled := true;
  edtPort.Enabled := true;
end;

procedure TfrmServers.btnAddNewServerClick(Sender: TObject);
var
  Name: string;
  Item: TServerItem;
begin
  Name := InputBox('New server name...', 'Please enter a name for the new server.', '');
  if Name <> '' then
  begin
    Item := Servers.Add;
    Item.Name := Name;
    lbServers.AddItem(Item.Name, Item);
  end;
end;

procedure TfrmServers.btnDeleteSelectedClick(Sender: TObject);
var
  Item: TServerItem;
begin
  if lbServers.ItemIndex > -1 then
  begin
    Item := TServerItem(lbServers.Items.Objects[lbServers.ItemIndex]);
    Servers.Delete(Item.Index);
    lbServers.Items.Delete(lbServers.ItemIndex);
  end;
end;

procedure TfrmServers.DeactivateDisplay;
begin
  btnDeleteSelected.Enabled := false;
  edtName.Text := '';
  edtName.Enabled := false;
  edtIPAddress.Text := '';
  edtIPAddress.Enabled := false;
  edtPort.Text := '';
  edtPort.Enabled := false;
  ActiveItem := nil;
end;

procedure TfrmServers.edtIPAddressExit(Sender: TObject);
begin
  if ActiveItem <> nil then
  begin
    ActiveItem.IP := edtIPAddress.Text;
  end;
end;

procedure TfrmServers.edtNameExit(Sender: TObject);
begin
  if ActiveItem <> nil then
  begin
    ActiveItem.Name := edtName.Text;
  end;
end;

procedure TfrmServers.edtPortExit(Sender: TObject);
begin
  if ActiveItem <> nil then
  begin
    ActiveItem.Port := StrToIntDef(edtPort.Text, 0);
  end;
end;

procedure TfrmServers.FormShow(Sender: TObject);
var
  I: Integer;
begin
  if Assigned(Servers) then
  begin
    lbServers.Clear;
    for I := 0 to Servers.Count - 1 do
      lbServers.AddItem(Servers[I].Name, Servers[I]);
  end;
  DeactivateDisplay;
end;

procedure TfrmServers.lbServersClick(Sender: TObject);
begin
  if lbServers.ItemIndex > -1 then
  begin
    ActivateDisplay;
    ActiveItem := TServerItem(lbServers.Items.Objects[lbServers.ItemIndex]);
    edtName.Text := ActiveItem.Name;
    edtIPAddress.Text := ActiveItem.IP;
    edtPort.Text := IntToStr(ActiveItem.Port);
  end
  else
    DeactivateDisplay;
end;

end.
